# Phase 4: Games

# Floor
execute if score countdown gameData matches 0 unless score game gameData matches 1 run scoreboard players operation floor gameData = floor const

# Reset Effects
execute if score countdown gameData matches 200 run effect clear @a

# Proceed Time
execute if score countdown gameData matches 0..200 run scoreboard players add countdown gameData 1

# Countdown
execute if score countdown gameData matches 100 as @a at @s run playsound minecraft:block.note_block.bit voice @s ~ ~ ~ 2 1
execute if score countdown gameData matches 100 run title @a title [{"text":"Starting in ","color":"yellow"},{"text":"5","color":"aqua"},{"text":"...","color":"yellow"}]
execute if score countdown gameData matches 120 as @a at @s run playsound minecraft:block.note_block.bit voice @s ~ ~ ~ 2 1
execute if score countdown gameData matches 120 run title @a title [{"text":"Starting in ","color":"yellow"},{"text":"4","color":"aqua"},{"text":"...","color":"yellow"}]
execute if score countdown gameData matches 140 as @a at @s run playsound minecraft:block.note_block.bit voice @s ~ ~ ~ 2 1
execute if score countdown gameData matches 140 run title @a title [{"text":"Starting in ","color":"yellow"},{"text":"3","color":"aqua"},{"text":"...","color":"yellow"}]
execute if score countdown gameData matches 160 as @a at @s run playsound minecraft:block.note_block.bit voice @s ~ ~ ~ 2 1
execute if score countdown gameData matches 160 run title @a title [{"text":"Starting in ","color":"yellow"},{"text":"2","color":"aqua"},{"text":"...","color":"yellow"}]
execute if score countdown gameData matches 180 as @a at @s run playsound minecraft:block.note_block.bit voice @s ~ ~ ~ 2 1
execute if score countdown gameData matches 180 run title @a title [{"text":"Starting in ","color":"yellow"},{"text":"1","color":"aqua"},{"text":"...","color":"yellow"}]
execute if score countdown gameData matches 200 as @a at @s run playsound minecraft:block.note_block.bit voice @s ~ ~ ~ 2 2
execute if score countdown gameData matches 200 run title @a title {"text":"GO!","color":"aqua"}

# Jumping Off
execute unless score game gameData matches 2..3 unless score game gameData matches 8 as @a[gamemode=!creative,gamemode=!spectator,scores={death=0}] at @s if entity @s[y=58,distance=..2] run scoreboard players set @s death 1

# On Death
execute as @a[scores={death=1},limit=1,sort=random] unless entity @a[scores={death=0}] run scoreboard players set @s death 0
execute as @a[scores={death=1}] run clear @s
execute as @a[scores={death=1}] at @s run particle minecraft:explosion ~ ~ ~ 0 0 0 0 0 force
execute as @a[scores={death=1}] at @s run playsound minecraft:entity.generic.explode voice @a ~ ~ ~ 1 0.8
execute as @a[scores={death=1}] run gamemode spectator @s[gamemode=adventure]
execute as @a[scores={death=1}] unless entity @a[scores={kill=1..}] run function other:cosmetics/messages/death
execute as @a[scores={death=1}] at @s as @a[scores={kill=1..},limit=1,sort=nearest] run function other:cosmetics/messages/killed
execute as @a[scores={death=1}] run scoreboard players set @s death 2
scoreboard players reset @a kill

# Force End
execute store result score alive gameData if entity @a[scores={death=0..1}]
execute if score alive gameData matches 0 run scoreboard players set phase gameData 6

# Run Games
execute if score countdown gameData matches 201 if score game gameData matches 1 run function game:meltdown/main
execute if score countdown gameData matches 201 if score game gameData matches 2 run function game:snowy_business/main
execute if score countdown gameData matches 201 if score game gameData matches 3 run function game:present_hunt/main
execute if score countdown gameData matches 201 if score game gameData matches 4 run function game:santas_standoff/main
execute if score countdown gameData matches 201 if score game gameData matches 5 run function game:icy_archers/main
execute if score countdown gameData matches 201 if score game gameData matches 6 run function game:vortex/main
execute if score countdown gameData matches 201 if score game gameData matches 7 run function game:invasion/main
execute if score countdown gameData matches 201 if score game gameData matches 8 run function game:meat_lovers/main
execute if score countdown gameData matches 201 if score game gameData matches 9 run function game:final_showdown/main

# Force End
execute if score phase gameData matches 4 if score alive gameData matches 1 run title @a title {"text":"Game Force Ended","color":"red"}
execute if score phase gameData matches 4 if score alive gameData matches 1 run title @a subtitle {"text":"All other players left","color":"red"}
execute if score phase gameData matches 4 if score alive gameData matches 1 run scoreboard players add roundsLeft gameData 1
execute if score phase gameData matches 4 if score alive gameData matches 1 run playsound entity.blaze.hurt voice @a ~ ~ ~ 999999 0.5
execute if score phase gameData matches 4 if score alive gameData matches 1 run scoreboard players set phase gameData 5